<?php
if (!defined('ABSPATH')) {
    exit;
}
if (!class_exists('SZBD_Google_Server_Requests')) {
class SZBD_Google_Server_Requests {

    const API_URL = 'https://maps.googleapis.com/maps/api/directions/json';
    
    const API_URL_GEOCODE = 'https://maps.googleapis.com/maps/api/geocode/json';

    public $api_key;

    public $debug;

    public function __construct($api_key) {
      $this->api_key = $api_key;

    }

    private function perform_request($params,$mode = 'directions') {
       
      $args = array(
        'timeout' => 4, // Default to 3 seconds.
        'redirection' => 0,
        'httpversion' => '1.0',
        'sslverify' => true,
        'blocking' => true,
        'user-agent' => 'PHP ' . PHP_VERSION . '/WooCommerce ' . get_option('woocommerce_db_version') ,
      );
      
      $api_url = $mode == 'geocode' ? self::API_URL_GEOCODE : self::API_URL; 

      $response = wp_remote_get($api_url  . '?' . (!empty($this->api_key) ? 'key=' . $this->api_key . '&' : '') . $params, $args);

      if (get_option('szbd_debug', 'no') == 'yes' && (is_checkout() || is_cart())) {
       
        parse_str($params, $params_debug);
       if(  !wc_has_notice( 'SERVER to GOOGLE CALL:<br/>URL:' .$api_url. '<br>Request: <br/><pre>' . print_r($params_debug, true) . '</pre>', 'notice') ){
        wc_add_notice( 'SERVER to GOOGLE CALL:<br/>URL:' .$api_url. '<br>Request: <br/><pre>' . print_r($params_debug, true) . '</pre>', 'notice');
      
        wc_add_notice('Response: <br/>' . '<pre>' . print_r($response['body'], true) . '</pre>', 'notice');
       }

      }

      if (is_wp_error($response)) {
        throw new Exception($response);
      }

      return $response;
    }

    public function get_distance($origin, $destination_, $mode, $avoid = '', $units = 'metric', $region = false) {

      $params = array();

      $params['origin'] = $origin;
      if(is_array($destination_)){
        $destination = $destination_[0] .',' . $destination_[1];
        
      }else{
        $destination = $destination_;
      }
      $params['destination'] = $destination;
      $params['mode'] = $mode;
      if (!empty($avoid)) {
        $params['avoid'] = $avoid;
      }
      $params['units'] = $units;

      if (!empty($region)) {
        $params['region'] = $region;
      }

      $params = http_build_query($params);
      
      
      $response = $this->perform_request($params);
      $distance = json_decode($response['body']);
       
       
       

      

      return $distance;
    }
     public function get_location($location, $region = false) {

      $params = array();

      
      $params['address'] = $location;
     

      if (!empty($region)) {
        $params['region'] = $region;
      }

      $params = http_build_query($params);
      $response_ = $this->perform_request($params,'geocode');
      $response = json_decode($response_['body']);

      return $response;
    }
  }
}
